#include <stdio.h>
#include <stdlib.h>
#include <string.h>

#include "ci067.h"
#include "agenda.h"
#include "agdbm.h"
#include "lista.h"

static endereco *leItem ()
{
  endereco *item;

  item = (endereco *) calloc (1, sizeof(endereco));

  if (item) {
    /* Obtem os dados de um item da agenda */
    printf("NOME: ");
    cigets(item->nome, TAM_NOME, stdin);
    
    if (strlen(item->nome)) {
      toupperStr(item->nome);
      
      /* Se forneceu um NOME, DEVE fornecer o FONE. Estes compoem a chave
       * interna de acesso */
      do {
	printf("FONE: ");
	cigets(item->fone, TAM_FONE, stdin);
      } while (!strlen(item->fone));
      
      printf("ENDERECO: ");
      cigets(item->end, TAM_END, stdin);
      toupperStr(item->end);
      
      printf("CIDADE: ");
      cigets(item->cidade, TAM_CIDADE, stdin);
      toupperStr(item->cidade);
      
      printf("ESTADO: ");
      cigets(item->estado, TAM_ESTADO, stdin);
      toupperStr(item->estado);
      
      printf("CEP: ");
      cigets(item->cep, TAM_CEP, stdin);
      
      printf("E-MAIL: ");
      cigets(item->email, TAM_EMAIL, stdin);
      
      printf("ANIVERSARIO: ");
      cigets(item->aniversario, TAM_ANIVERSARIO, stdin);
      
      printf("\n\n%%%%%%%%%%%%%%%%%%%%%%\n\n");
    }
    else {
      free (item);
      item = NULL;
    }
  }

  return item;
}

static void atualiza (lista *itens)
{

}

void armazenar ()
{
  lista *agenda,
        *itens;
  endereco *item;

  if (db_open (DBASE_NOME, UPDATE)) {
    printf("\n\n Entre com os itens da agenda. NOME e FONE sao obrigatorios.\n");
    printf("Para terminar, digite <ENTER> como valor do campo NOME.\n\n");

    do {
      if (item = leItem()) {
	DEBUGMSG ("*** DEBUG **** NOME LIDO = %s\n", item->nome);
	/* Se item jah  existe, pergunta se quer
	 * atualizar ou armazenar um novo */
	if ((itens = db_query(item->nome, QUERY_BY_NAME))) {
	  atualiza (itens);
	  /* Insere itens atualizados na agenda */
	  agenda = acrescenta (itens, agenda);
	}
	else
	  agenda = insere (item, agenda);
      }
    } while (item);
    
    db_store (agenda);
    db_close();
  }  /* FIM (db_open(UPDATE)) */
}


